var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "GraphEditor", {
  enumerable: true,
  get: function get() {
    return _graphEditor.default;
  }
});
Object.defineProperty(exports, "GraphView", {
  enumerable: true,
  get: function get() {
    return _graphView.default;
  }
});
exports.default = void 0;
exports.install = install;
exports.version = void 0;

var _graphEditor = _interopRequireDefault(require("./graph-editor"));

var _graphView = _interopRequireDefault(require("./graph-view"));

var version = '1.1.11';
exports.version = version;

function install(Vue) {
  var components = [_graphEditor.default, _graphView.default];
  components.forEach(function (item) {
    if (item.install) {
      Vue.use(item);
    } else if (item.name) {
      Vue.component(item.name, item);
    }
  });
}

if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue);
}

var _default = {
  install: install,
  version: version
};
exports.default = _default;