var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _basic = _interopRequireDefault(require("./basic.js"));

var _config = _interopRequireDefault(require("./utils/config.js"));

var _default2 = _interopRequireDefault(require("./utils/default.js"));

require("./index-sfc.css");

var __vue_render__ = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticStyle: {
      "width": "100%",
      "height": "100%"
    }
  }, [_c('div', {
    staticClass: "draw_graph_header"
  }, [_c('button', {
    on: {
      "click": _vm.save
    }
  }, [_vm._v("保存")]), _vm._v(" "), _c('button', {
    on: {
      "click": _vm.back
    }
  }, [_vm._v("上一步")]), _vm._v(" "), _c('button', {
    on: {
      "click": _vm.next
    }
  }, [_vm._v("下一步")]), _vm._v(" "), _c('button', {
    on: {
      "click": _vm.zoomIn
    }
  }, [_vm._v("+")]), _vm._v(" "), _c('button', {
    on: {
      "click": _vm.zoomOut
    }
  }, [_vm._v("-")]), _vm._v(" "), _c('button', {
    on: {
      "click": _vm.print
    }
  }, [_vm._v("打印")])]), _vm._v(" "), _vm._m(0)]);
};

var __vue_staticRenderFns__ = [function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "draw_graph_warp"
  }, [_c('div', {
    staticClass: "draw_graph_toolbar"
  }, [_c('h6', [_vm._v("基础图形")]), _vm._v(" "), _c('div', {
    attrs: {
      "id": "draw_graph_toolbar_basic"
    }
  }), _vm._v(" "), _c('h6', [_vm._v("自定义图形")]), _vm._v(" "), _c('div', {
    attrs: {
      "id": "draw_graph_toolbar_drap"
    }
  }, [_vm._v("\n\t\t\t\t将元素拖到此处(图片)\n\t\t\t")]), _vm._v(" "), _c('div', {
    attrs: {
      "id": "draw_graph_toolbar_img"
    }
  })]), _vm._v(" "), _c('div', {
    attrs: {
      "id": "draw_graph_container"
    }
  }), _vm._v(" "), _c('div', {
    staticStyle: {
      "position": "absolute",
      "overflow": "hidden",
      "bottom": "0px",
      "right": "0px",
      "width": "200px",
      "height": "140px",
      "background": "transparent",
      "border-style": "solid",
      "border-color": "black"
    },
    attrs: {
      "id": "outlineContainer"
    }
  })]);
}];
var _default = {
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__,
  name: "graph-editor",
  props: {},
  data: function data() {
    return {
      graph: null,
      editor: null,
      model: null,
      undoManager: null,
      imgToolbar: null,
      basicToolbar: null,
      basic: []
    };
  },
  mounted: function mounted() {
    this.init();
    this.drag();
    this.basicToolbarInit();
    this.outline();
    this.createPopupMenu();
  },
  methods: {
    init: function init() {
      var container = document.getElementById("draw_graph_container");
      container.style.background = 'url("data:image/gif;base64,R0lGODlhCgAKAIAAAP///+fv3iH5BAEAAAAALAAAAAAKAAoAAAIRjI8By6zdHlxyVnjjdJt2UAAAOw==")';
      var model = new mxGraphModel();
      this.graph = new Graph(container, model); //工具栏

      this.imgToolbar = new mxToolbar(document.getElementById("draw_graph_toolbar_img"));
      this.imgToolbar.enabled = false;
      this.basicToolbar = new mxToolbar(document.getElementById("draw_graph_toolbar_basic"));
      this.basicToolbar.enabled = false; //创建上下一步的对象

      this.undoManager = this.createUndoManager(); // 设置风格样式themes default.xml文件

      var themsXml = mxUtils.parseXml(_default2.default);
      new mxCodec().decode(themsXml.documentElement, this.graph.getStylesheet());
    },
    //addVertex
    addVertex: function addVertex(icon, w, h, style, toolbar, imgbase64) {
      var vertex = new mxCell(null, new mxGeometry(0, 0, w, h), style);
      vertex.setVertex(true);
      this.addToolbarItem(this.graph, toolbar, vertex, icon, imgbase64);
    },
    //新增toolbar
    addToolbarItem: function addToolbarItem(graph, toolbar, prototype, image, imgbase64) {
      var funct = function funct(graph, evt, cell) {
        graph.stopEditing(false);
        var pt = graph.getPointForEvent(evt);
        var vertex = graph.getModel().cloneCell(prototype);
        vertex.geometry.x = pt.x;
        vertex.geometry.y = pt.y;
        graph.setSelectionCells(graph.importCells([vertex], 0, 0, cell));
      };

      var toolbarImg;

      if (imgbase64) {
        toolbarImg = toolbar.addMode(null, image, funct);
      } else {
        toolbarImg = toolbar.addModeSvg(null, image, funct);
      }

      mxUtils.makeDraggable(toolbarImg, graph, funct);
    },
    //保存
    save: function save() {
      var encoder = new mxCodec();
      var node = encoder.encode(this.graph.getModel());
      console.log(node);
    },
    //创建上下一步对象
    createUndoManager: function createUndoManager() {
      var graph = this.graph;
      var undoMgr = new mxUndoManager();

      graph.undoListener = function (sender, evt) {
        undoMgr.undoableEditHappened(evt.getProperty('edit'));
      }; // Installs the command history


      var listener = mxUtils.bind(this, function (sender, evt) {
        graph.undoListener.apply(this, arguments);
      });
      graph.getModel().addListener(mxEvent.UNDO, listener);
      graph.getView().addListener(mxEvent.UNDO, listener); // Keeps the selection in sync with the history

      var undoHandler = function undoHandler(sender, evt) {};

      undoMgr.addListener(mxEvent.UNDO, undoHandler);
      undoMgr.addListener(mxEvent.REDO, undoHandler);
      return undoMgr;
    },
    //上一步
    back: function back() {
      this.undoManager.undo();
    },
    // 下一步
    next: function next() {
      this.undoManager.redo();
    },
    zoomIn: function zoomIn() {
      this.graph.zoomIn();
    },
    zoomOut: function zoomOut() {
      this.graph.zoomOut();
    },
    print: function print() {
      var preview = new mxPrintPreview(this.graph, 1);
      preview.autoOrigin = false;
      preview.printOverlays = true;
      preview.open();
    },
    // 右键菜单
    createPopupMenu: function createPopupMenu() {
      var _this = this;

      //右键菜单
      this.graph.popupMenuHandler.factoryMethod = function (menu, cell, evt) {
        //取消默认的浏览器自带右键
        document.getElementById('draw_graph_container').oncontextmenu = function (e) {
          return false;
        };

        if (cell != null) {
          menu.addItem('删除', null, function () {
            _this.graph.removeCells([cell]);
          });
        }
      };
    },
    //拖曳
    drag: function drag() {
      var _this2 = this;

      //拖曳
      var dragContainer = document.getElementById('draw_graph_toolbar_drap');
      mxEvent.addListener(dragContainer, 'dragover', function (evt) {
        evt.preventDefault();
      });
      mxEvent.addListener(dragContainer, 'drop', function (evt) {
        evt.preventDefault();
        var file = event.dataTransfer.files[0];
        var reader = new FileReader();
        reader.readAsDataURL(file);

        reader.onload = function (e) {
          _this2.imgToolbarInit(e.target.result);
        };
      });
    },
    //基础toolbar图形渲染
    basicToolbarInit: function basicToolbarInit() {
      var _this3 = this;

      //渲染基础图形
      _basic.default.map(function (item) {
        _this3.addVertex(item.icon, item.w, item.h, item.value, _this3.basicToolbar, false);
      });
    },
    imgToolbarInit: function imgToolbarInit(e) {
      var _this4 = this;

      //自定义图形
      if (e) {
        var newImage = new Image();
        newImage.src = e;

        newImage.onload = function () {
          var width = _this4.maxImage(newImage.width, newImage.height, 120, 120).width;

          var height = _this4.maxImage(newImage.width, newImage.height, 120, 120).height; //移出 ;base64	字符串，mxgraph做这个做了处理 真坑


          value = "shape=image;verticalLabelPosition=bottom;labelBackgroundColor=default;verticalAlign=top;aspect=fixed;imageAspect=0;image=" + newImage.src.replace(';base64', '');

          _this4.addVertex(newImage.src, width, height, value, _this4.imgToolbar, true);
        };
      }
    },
    //缩小比例图
    outline: function outline() {
      var outline = document.getElementById('outlineContainer');
      var outln = new mxOutline(this.graph, outline);
    },
    //图片按比例缩放一下
    maxImage: function maxImage(width, height, maxWidth, maxHeight) {
      // 用于设定图片的宽度和高度
      var tempWidth;
      var tempHeight;

      if (width > 0 && height > 0) {
        //原图片宽高比例 大于 指定的宽高比例，这就说明了原图片的宽度必然 > 高度
        if (width / height >= maxWidth / maxHeight) {
          if (width > maxWidth) {
            tempWidth = maxWidth; // 按原图片的比例进行缩放

            tempHeight = height * maxWidth / width;
          } else {
            // 按原图片的大小进行缩放
            tempWidth = width;
            tempHeight = height;
          }
        } else {
          // 原图片的高度必然 > 宽度
          if (height > maxHeight) {
            tempHeight = maxHeight; // 按原图片的比例进行缩放

            tempWidth = width * maxHeight / height;
          } else {
            // 按原图片的大小进行缩放
            tempWidth = width;
            tempHeight = height;
          }
        }

        var img = {
          width: tempWidth,
          height: tempHeight
        };
        return img;
      }
    }
  }
};
exports.default = _default;